package gr.uoi.cs.privacy.network;

import java.util.Iterator;
import java.util.Vector;

public class Network {
	protected Vector<Node> nodes;
	protected Vector<Edge> edges;
	protected int adjMatrix[][];
	
	public Network(int N){
		nodes = new Vector<Node>();
		edges = new Vector<Edge>();
		adjMatrix = new int[N][N];
	}
	
	public int addNode(Node n){
		Node N = new Node(n.getId(), Integer.toString(n.getId()));
		this.nodes.add(N);
		return 1;
		//TODO don't add same node
	}
	
	public int addEdge(Edge e){
		Node[] n = e.getNodes();
		adjMatrix[n[0].getId()][n[1].getId()] = 1;
//		adjMatrix[n[1].getId()][n[0].getId()] = 1;
		edges.add(e);
		return 1;
		//TODO don't add same edge
	}
	
	public int[][] getAdjMatrix(){
		return this.adjMatrix;
	}
	
	public Vector<Node> getNodes(){
		return this.nodes;
	}
	
	public Vector<Edge> getEdges(){
		return this.edges;
	}
	
	public void removeEdge(int a, int b){
		Edge tmp = this.findEdge(a, b);
		if (tmp!=null){
			this.edges.remove(tmp);
		}
		adjMatrix[a][b] = 0;
	}
	
	public Edge findEdge(int a, int b){
		Iterator<Edge> it = this.edges.iterator();
		Edge tmp = null;
		while (it.hasNext()){
			tmp = it.next();
			if (tmp.getNodes()[0].getId() == a && tmp.getNodes()[1].getId() == b){
				return tmp;
			}
		}
		return null; 
	}
}
