package gr.uoi.cs.privacy.network;

import java.util.Random;
import java.util.Vector;

public class SmallWorld extends RingLattice {

	public SmallWorld(int N, int K, double p) {
		super(N, K);
		Random gen = new Random();
		boolean zero[];
		Vector<int[]> v = new Vector<int[]>();
		boolean needsFix = false;
		for (int i = 0; i < N-1; i++){
			zero = new boolean[N];
			for (int l = 0; l < N; l++ ){
				if (adjMatrix[i][l] != 0 || i == l){
					zero[l] = true;
				}
			}
			v.clear();
			for (int j = i+1; j < N; j++){
				if (adjMatrix[i][j] == 1 && gen.nextDouble() <= p){
					int k = 0;
					do {
						k = gen.nextInt(zero.length);
					} while (zero[k]);
					zero[j] = true;
					int a[] = new int[2];
					a[0] = j;
					a[1] = k;
					v.add(a);
					needsFix = true;
				}
			}
			if (needsFix){
				fixMatrix(i, v);
				needsFix = false;
			}
		}
	}
	
	private void fixMatrix(int row, Vector<int[]> v){
		for (int i = 0; i < v.size(); i++){
			int a[] = v.get(i);
			removeEdge(row, a[0]);
			removeEdge(a[0], row);
			Edge e1 = new Edge(nodes.get(row), nodes.get(a[1]));
			Edge e2 = new Edge(nodes.get(a[1]), nodes.get(row));
			addEdge(e1);
			addEdge(e2);
		}
	}
}

